NIX-BUILD(1)

NAME
nix-build - build a Nix expression

SYNOPSIS

nix-build [--help] [--version] [{--verbose | -v}...] [--no-build-output | -Q] [{--max-jobs | -j} number] [--cores number] [--max-silent-time number] [--timeout number] [--keep-going | -k] [--keep-failed | -K] [--fallback] [--readonly-mode] [-I path] [--option name value]
[--arg name value] [--argstr name value] [{--attr | -A} attrPath] [--no-out-link] [{--out-link | -o} outlink] paths...

DESCRIPTION

The nix-build command builds the derivations described by the Nix expressions in paths. If the build succeeds, it places a symlink to the result in the current directory. The symlink is called result. If there are multiple Nix expressions, or the Nix expressions evaluate to multiple derivations, multiple sequentially numbered symlinks are created (result, result-2, and so on).

If no paths are specified, then nix-build will use default.nix in the current directory, if it exists.

If an element of paths starts with http:// or https://, it is interpreted as the URL of a tarball that will be downloaded and unpacked to a temporary location. The tarball must include a single top-level directory containing at least a file named default.nix.

nix-build is essentially a wrapper around nix-instantiate (to translate a high-level Nix expression to a low-level store derivation) and nix-store --realise (to build the store derivation).

    Warning

    The result of the build is automatically registered as a root of the Nix garbage collector. This root disappears automatically when the result symlink is deleted or renamed. So don’t rename the symlink.

OPTIONS

All options not listed here are passed to nix-store --realise, except for --arg and --attr / -A which are passed to nix-instantiate.

--no-out-link
    Do not create a symlink to the output path. Note that as a result the output does not become a root of the garbage collector, and so might be deleted by nix-store --gc.

--out-link / -o outlink
    Change the name of the symlink to the output path created from result to outlink.

The following common options are supported:

--help
    Prints out a summary of the command syntax and exits.

--version
    Prints out the Nix version number on standard output and exits.

--verbose / -v
    Increases the level of verbosity of diagnostic messages printed on standard error. For each Nix operation, the information printed on standard output is well-defined; any diagnostic information is printed on standard error, never on standard output.

    This option may be specified repeatedly. Currently, the following verbosity levels exist:

    0
        “Errors only”: only print messages explaining why the Nix invocation failed.

    1
        “Informational”: print useful messages about what Nix is doing. This is the default.

    2
        “Talkative”: print more informational messages.

    3
        “Chatty”: print even more informational messages.

    4
        “Debug”: print debug information.

    5
        “Vomit”: print vast amounts of debug information.

--no-build-output / -Q
    By default, output written by builders to standard output and standard error is echoed to the Nix command's standard error. This option suppresses this behaviour. Note that the builder's standard output and error are always written to a log file in prefix/nix/var/log/nix.

--max-jobs / -j number
    Sets the maximum number of build jobs that Nix will perform in parallel to the specified number. Specify auto to use the number of CPUs in the system. The default is specified by the max-jobs configuration setting, which itself defaults to 1. A higher value is useful on SMP systems or to exploit I/O latency.

--cores
    Sets the value of the NIX_BUILD_CORES environment variable in the invocation of builders. Builders can use this variable at their discretion to control the maximum amount of parallelism. For instance, in Nixpkgs, if the derivation attribute enableParallelBuilding is set to true, the builder passes the -jN flag to GNU Make. It defaults to the value of the cores configuration setting, if set, or 1 otherwise. The value 0 means that the builder should use all available CPU cores in the system.

--max-silent-time
    Sets the maximum number of seconds that a builder can go without producing any data on standard output or standard error. The default is specified by the max-silent-time configuration setting. 0 means no time-out.

--timeout
    Sets the maximum number of seconds that a builder can run. The default is specified by the timeout configuration setting. 0 means no timeout.

--keep-going / -k
    Keep going in case of failed builds, to the greatest extent possible. That is, if building an input of some derivation fails, Nix will still build the other inputs, but not the derivation itself. Without this option, Nix stops if any build fails (except for builds of substitutes), possibly killing builds in progress (in case of parallel or distributed builds).

--keep-failed / -K
    Specifies that in case of a build failure, the temporary directory (usually in /tmp) in which the build takes place should not be deleted. The path of the build directory is printed as an informational message.

--fallback
    Whenever Nix attempts to build a derivation for which substitutes are known for each output path, but realising the output paths through the substitutes fails, fall back on building the derivation.

    The most common scenario in which this is useful is when we have registered substitutes in order to perform binary distribution from, say, a network repository. If the repository is down, the realisation of the derivation will fail. When this option is specified, Nix will build the derivation instead. Thus, installation from binaries falls back on installation from source. This option is not the default since it is generally not desirable for a transient failure in obtaining the substitutes to lead to a full build from source (with the related consumption of resources).

--no-build-hook
    Disables the build hook mechanism. This allows to ignore remote builders if they are setup on the machine.

    It's useful in cases where the bandwidth between the client and the remote builder is too low. In that case it can take more time to upload the sources to the remote builder and fetch back the result than to do the computation locally.

--readonly-mode
    When this option is used, no attempt is made to open the Nix database. Most Nix operations do need database access, so those operations will fail.

--arg name value
    This option is accepted by nix-env, nix-instantiate and nix-build. When evaluating Nix expressions, the expression evaluator will automatically try to call functions that it encounters. It can automatically call functions for which every argument has a default value (e.g., { argName ? defaultValue }: ...). With --arg, you can also call functions that have arguments without a default value (or override a default value). That is, if the evaluator encounters a function with an argument named name, it will call it with value value.

    For instance, the top-level default.nix in Nixpkgs is actually a function:

        { # The system (e.g., `i686-linux') for which to build the packages.
          system ? builtins.currentSystem
          ...
        }: ...

    So if you call this Nix expression (e.g., when you do nix-env -i pkgname), the function will be called automatically using the value builtins.currentSystem for the system argument. You can override this using --arg, e.g., nix-env -i pkgname --arg system \"i686-freebsd\". (Note that since the argument is a Nix string literal, you have to escape the quotes.)

--argstr name value
    This option is like --arg, only the value is not a Nix expression but a string. So instead of --arg system \"i686-linux\" (the outer quotes are to keep the shell happy) you can say --argstr system i686-linux.

--attr / -A attrPath
    Select an attribute from the top-level Nix expression being evaluated. (nix-env, nix-instantiate, nix-build and nix-shell only.) The attribute path attrPath is a sequence of attribute names separated by dots. For instance, given a top-level Nix expression e, the attribute path xorg.xorgserver would cause the expression e.xorg.xorgserver to be used. See nix-env --install for some concrete examples.

    In addition to attribute names, you can also specify array indices. For instance, the attribute path foo.3.bar selects the bar attribute of the fourth element of the array in the foo attribute of the top-level expression.

--expr / -E
    Interpret the command line arguments as a list of Nix expressions to be parsed and evaluated, rather than as a list of file names of Nix expressions. (nix-instantiate, nix-build and nix-shell only.)

-I path
    Add a path to the Nix expression search path. This option may be given multiple times. See the NIX_PATH environment variable for information on the semantics of the Nix search path. Paths added through -I take precedence over NIX_PATH.

--option name value
    Set the Nix configuration option name to value. This overrides settings in the Nix configuration file (see nix.conf(5)).

--repair
    Fix corrupted or missing store paths by redownloading or rebuilding them. Note that this is slow because it requires computing a cryptographic hash of the contents of every path in the closure of the build. Also note the warning under nix-store --repair-path.

EXAMPLES

    $ nix-build '<nixpkgs>' -A firefox
    store derivation is /nix/store/qybprl8sz2lc...-firefox-1.5.0.7.drv
    /nix/store/d18hyl92g30l...-firefox-1.5.0.7
    $ ls -l result
    lrwxrwxrwx  ...  result -> /nix/store/d18hyl92g30l...-firefox-1.5.0.7
    $ ls ./result/bin/
    firefox  firefox-config

If a derivation has multiple outputs, nix-build will build the default (first) output. You can also build all outputs:

    $ nix-build '<nixpkgs>' -A openssl.all

This will create a symlink for each output named result-outputname. The suffix is omitted if the output name is out. So if openssl has outputs out, bin and man, nix-build will create symlinks result, result-bin and result-man. It’s also possible to build a specific output:

    $ nix-build '<nixpkgs>' -A openssl.man

This will create a symlink result-man.

Build a Nix expression given on the command line:

    $ nix-build -E 'with import <nixpkgs> { }; runCommand "foo" { } "echo bar > $out"'
    $ cat ./result
    bar

Build the GNU Hello package from the latest revision of the master branch of Nixpkgs:

    $ nix-build https://github.com/NixOS/nixpkgs/archive/master.tar.gz -A hello

ENVIRONMENT VARIABLES

IN_NIX_SHELL
    Indicator that tells if the current environment was set up by nix-shell.

NIX_PATH
    A colon-separated list of directories used to look up Nix expressions enclosed in angle brackets (i.e., <path>). For instance, the value

        /home/eelco/Dev:/etc/nixos

    will cause Nix to look for paths relative to /home/eelco/Dev and /etc/nixos, in that order. It is also possible to match paths against a prefix. For example, the value

        nixpkgs=/home/eelco/Dev/nixpkgs-branch:/etc/nixos

    will cause Nix to search for <nixpkgs/path> in /home/eelco/Dev/nixpkgs-branch/path and /etc/nixos/nixpkgs/path.

    If a path in the Nix search path starts with http:// or https://, it is interpreted as the URL of a tarball that will be downloaded and unpacked to a temporary location. The tarball must consist of a single top-level directory. For example, setting NIX_PATH to

        nixpkgs=https://github.com/NixOS/nixpkgs-channels/archive/nixos-14.12.tar.gz

    tells Nix to download the latest revision in the Nixpkgs/NixOS 14.12 channel.

    The search path can be extended using the -I option, which takes precedence over NIX_PATH.

NIX_IGNORE_SYMLINK_STORE
    Normally, the Nix store directory (typically /nix/store) is not allowed to contain any symlink components. This is to prevent “impure” builds. Builders sometimes “canonicalise” paths by resolving all symlink components. Thus, builds on different machines (with /nix/store resolving to different locations) could yield different results. This is generally not a problem, except when builds are deployed to machines where /nix/store resolves differently. If you are sure that you’re not going to do that, you can set NIX_IGNORE_SYMLINK_STORE to 1.

    Note that if you’re symlinking the Nix store so that you can put it on another file system than the root file system, on Linux you’re better off using bind mount points, e.g.,

        $ mkdir /nix
        $ mount -o bind /mnt/otherdisk/nix /nix

    Consult the mount(8) manual page for details.

NIX_STORE_DIR
    Overrides the location of the Nix store (default prefix/store).

NIX_DATA_DIR
    Overrides the location of the Nix static data directory (default prefix/share).

NIX_LOG_DIR
    Overrides the location of the Nix log directory (default prefix/log/nix).

NIX_STATE_DIR
    Overrides the location of the Nix state directory (default prefix/var/nix).

NIX_CONF_DIR
    Overrides the location of the Nix configuration directory (default prefix/etc/nix).

TMPDIR
    Use the specified directory to store temporary files. In particular, this includes temporary build directories; these can take up substantial amounts of disk space. The default is /tmp.

NIX_REMOTE
    This variable should be set to daemon if you want to use the Nix daemon to execute Nix operations. This is necessary in multi-user Nix installations. If the Nix daemon's Unix socket is at some non-standard path, this variable should be set to unix://path/to/socket. Otherwise, it should be left unset.

NIX_SHOW_STATS
    If set to 1, Nix will print some evaluation statistics, such as the number of values allocated.

NIX_COUNT_CALLS
    If set to 1, Nix will print how often functions were called during Nix expression evaluation. This is useful for profiling your Nix expressions.

GC_INITIAL_HEAP_SIZE
    If Nix has been configured to use the Boehm garbage collector, this variable sets the initial size of the heap in bytes. It defaults to 384 MiB. Setting it to a low value reduces memory consumption, but will increase runtime due to the overhead of garbage collection.

AUTHOR

Eelco Dolstra
    Author

COPYRIGHT
Copyright © 2004-2018 Eelco Dolstra